// [[Rcpp::depends(RcppArmadillo)]]
#include <RcppArmadillo.h>

using namespace Rcpp;

//' For computing the 3D array OmegaAAAd.
//'
//' @param bdddVec numeric vector
//' @param XA numeric matrix
//' @param nTot numeric integer
//' @param dR numeric integer
//' @return OmegaAAAd 3D array
// [[Rcpp::export(OmegaAAAd)]]
arma::cube OmegaAAAd(arma::vec bdddVec, arma::mat XA, int nTot, int dR)
{
  arma::cube OmegaAAAd(dR,dR,dR,arma::fill::value(0.0));
              
  for(int k = 0; k < nTot; k++)
  {
    for(int r = 0; r < dR; r++)
    {
      for(int s = r; s < dR; s++)
      {
        for(int t = 0; t < dR; t++)
        {
          OmegaAAAd(r,s,t) += bdddVec(k)*XA(k,r)*XA(k,s)*XA(k,t)/nTot;
          OmegaAAAd(s,r,t) = OmegaAAAd(r,s,t);
        }
      }
    }
  }

  return OmegaAAAd;
}
