// [[Rcpp::depends(RcppArmadillo)]]
#include <RcppArmadillo.h>

using namespace Rcpp;

//' For computing the 3D array OmegaAABd.
//'
//' @param bdddVec numeric vector
//' @param XA numeric matrix
//' @param XB numeric matrix
//' @param nTot numeric integer
//' @param dR numeric integer
//' @return OmegaAABd 3D array
// [[Rcpp::export(OmegaAABd)]]
arma::cube OmegaAABd(arma::vec bdddVec, arma::mat XA, arma::mat XB, int nTot, int dR, int dF)
{
  int dFmdR = dF - dR;
  arma::cube OmegaAABd(dR,dR,dFmdR,arma::fill::value(0.0));
              
  for(int k = 0; k < nTot; k++)
  {
    for(int r = 0; r < dR; r++)
    {
      for(int s = r; s < dR; s++)
      {
        for(int td = 0; td < dFmdR; td++)
        {
          OmegaAABd(r,s,td) += bdddVec(k)*XA(k,r)*XA(k,s)*XB(k,td)/nTot;
          OmegaAABd(s,r,td) = OmegaAABd(r,s,td);
        }
      }
    }
  }

  return OmegaAABd;
}
