// [[Rcpp::depends(RcppArmadillo)]]
#include <RcppArmadillo.h>

using namespace Rcpp;

//' Star product between a 3D array and a matrix.
//'
//' @param A numeric cube
//' @param M numeric matrix
//' @param d1 numeric integer
//' @param d2 numeric integer
//' @param d3 numeric integer
//' @return star product
// [[Rcpp::export(starProd)]]
arma::vec starProd(arma::cube A, arma::mat M, int d1, int d2, int d3)
{
  arma::vec resVec(d3,arma::fill::value(0.0));
  for(int k = 0; k < d3; k++)
  {
    for(int i = 0; i < d1; i++)
    {
      for(int j = 0; j < d2; j++)
      {
        resVec(k) += A(i,j,k)*M(i,j);
      }
    }
  }
  return resVec;
}
